/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008-2011 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef _PROJECT_VIEW_TESTS_H_
#define _PROJECT_VIEW_TESTS_H_

#include "GUITests.h"

#include <QtCore/QString>

namespace U2 {

class ProjectViewTests: public GUITest {
public:
    ProjectViewTests(const QString &name): GUITest(name) {}
    void openFile(const QString &path);
    void addObjectToView(const QString &objectName);
    void openDocumentInView(const QString &documentName);

protected:
    static const QString projectViewName;
};

class TaskViewTest: public GUITest {
public:
    TaskViewTest(const QString &name): GUITest(name) {}
    QString getTaskProgress(const QString &taskName);
    QString getTaskState(const QString &taskName);
    void cancelTask(const QString &taskName);

protected:
    static const QString taskViewWidgetName;
};



}

#endif