/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008-2011 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#pragma once

#include <ui/ui_ExpertDiscoveryPosNegDialog.h>

namespace U2 {

class ExpertDiscoveryPosNegDialog : public QDialog, public Ui_ExpertDiscoveryPosNegDialog{
    Q_OBJECT
public:
    ExpertDiscoveryPosNegDialog(QWidget *parent);

    virtual void accept();

    QString getFirstFileName() const {return firstFileName;}
    QString getSecondFileName() const {return secondFileName;}
    bool isGenerateNegative() const {return generateNeg;}
protected slots:
    void sl_openFirstFile();
    void sl_openSecondFile();
    void sl_oneSequence();

private:
    QString firstFileName;
    QString secondFileName;

    bool generateNeg;

    QString filter;

};

}//namespace
